import numpy as np
from matplotlib.colors import LinearSegmentedColormap as LSC

def ccmap(cmap1, cmap2, order=1):
    N1 = cmap1.N
    N2 = cmap2.N
    N = N1+N2
    fract1 = np.linspace(0, 1, N1)
    fract2 = np.linspace(0, 1, N2)
    red1 = cmap1(fract1)[:,0]
    grn1 = cmap1(fract1)[:,1]
    blu1 = cmap1(fract1)[:,2]
    alf1 = cmap1(fract1)[:,3]
    red2 = cmap2(fract2)[:,0]
    grn2 = cmap2(fract2)[:,1]
    blu2 = cmap2(fract2)[:,2]
    alf2 = cmap2(fract2)[:,3]
    
# put in to tuple & dictionary structures needed
    rr = []
    bb = []
    gg = []
    aa = []
    if order < 0:
        for k in range(0, N1):
            rr.append((float(k) / (N - 1.), red2[N1-1-k], red2[N1-1-k]))
            bb.append((float(k) / (N - 1.), blu2[N1-1-k], blu2[N1-1-k]))
            gg.append((float(k) / (N - 1.), grn2[N1-1-k], grn2[N1-1-k]))
            aa.append((float(k) / (N - 1.), alf2[N1-1-k], alf2[N1-1-k]))
        for k in range(N1, N):
            rr.append((float(k) / (N - 1.), red1[N2-1-k], red1[N2-1-k]))
            bb.append((float(k) / (N - 1.), blu1[N2-1-k], blu1[N2-1-k]))
            gg.append((float(k) / (N - 1.), grn1[N2-1-k], grn1[N2-1-k]))
            aa.append((float(k) / (N - 1.), alf1[N2-1-k], alf1[N2-1-k]))
    else:
        for k in range(0, N1):
            rr.append((float(k) / (N - 1.), red1[k], red1[k]))
            bb.append((float(k) / (N - 1.), blu1[k], blu1[k]))
            gg.append((float(k) / (N - 1.), grn1[k], grn1[k]))
            aa.append((float(k) / (N - 1.), alf1[k], alf1[k]))
        for k in range(N1, N):
            rr.append((float(k) / (N - 1.), red2[k-N1], red2[k-N1]))
            bb.append((float(k) / (N - 1.), blu2[k-N1], blu2[k-N1]))
            gg.append((float(k) / (N - 1.), grn2[k-N1], grn2[k-N1]))
            aa.append((float(k) / (N - 1.), alf2[k-N1], alf2[k-N1]))

    cdict = {'red': rr, 'blue': bb, 'green': gg, 'alpha:': aa}
    return LSC('combined_map', cdict, N=N)
