import numpy as np

nlevels = 8
infolder = ''
#infolder = '/Users/ingothies/RGB_palettes/'
#infolder = '/Users/ingo/RGB_palettes/'
#infolder = '/users/ithies/RGB_palettes/'
#infile = 'rainbow-400-700-ciecam02-g07-bright.rgb'
#infile = 'spectrum01_blackbg.rgb'
#infile = 'pycolorhelix_purple2yellow.rgba'
infile = 'x.rgba'
inpath = infolder+infile
outfile = 'discrete.rgb'

def linint(xa, ya, x):
    n = len(xa)-1
    k0 = 0
    k1 = n
    if xa[n] < xa[0]:
        order = -1
    else:
        order = 1

    xmin = min(xa)
    xmax = max(xa)

    if x < xmin:
        c = x-xa[0]
        d = xa[1]-xa[0]
        s = (ya[1]-ya[0])/d
        y = c*s+ya[0]
    elif x > xmax:
        c = x-xa[n-1]
        d = xa[n]-xa[n-1]
        s = (ya[n]-ya[n-1])/d
        y = c*s+ya[n-1]
    else:
        # do interpolation
        while k1-k0 > 1:
            k = int((k1+k0)/2)
            if order*xa[k] > order*x:
                k1 = k
            else:
                k0 = k
        
        k = k0
        c = x-xa[k0]
        d = xa[k1]-xa[k0]
        s = (ya[k1]-ya[k0])/d
        y = c*s+ya[k0]
    return y, s

cmap = np.loadtxt(inpath)

nlin = len(cmap)
ncol = len(cmap[0])
print('nlin = ', nlin)
print('ncol = ', ncol)

levmin = cmap[0][0]
levmax = cmap[nlin-1][0]
dx = (levmax-levmin)/nlevels

ay = []
ar = []
ag = []
ab = []
aa = []

for i in range(nlin):
    ay.append(cmap[i][0])
    ar.append(cmap[i][1])
    ag.append(cmap[i][2])
    ab.append(cmap[i][3])
    if ncol == 5:
        aa.append(cmap[i][4])
    else:
        aa.append(0)
        
with open(outfile, 'w') as fout:
    for i in range(nlevels):
        x0 = levmin+i*dx
        x1 = x0+dx
        xu = x0*nlevels/(nlevels-1)
        r, sr = linint(ay, ar, xu)
        g, sg = linint(ay, ag, xu)
        b, sb = linint(ay, ab, xu)
        a, sa = linint(ay, aa, xu)
        if ncol == 5:
            fout.write('{:16.8f} {:8.6f} {:8.6f} {:8.6f} {:8.6f}\n'.format(x0, r, g, b, a))
            if i < nlevels: fout.write('{:16.8f} {:8.6f} {:8.6f} {:8.6f} {:8.6f}\n'.format(x1, r, g, b, a))
        else:
            fout.write('{:16.8f} {:8.6f} {:8.6f} {:8.6f}\n'.format(x0, r, g, b))
            if i < nlevels: fout.write('{:16.8f} {:8.6f} {:8.6f} {:8.6f}\n'.format(x1, r, g, b))
