import numpy as np
from matplotlib.colors import LinearSegmentedColormap as LSC
'''
In matplotlib up to 3.1.1 RGB components are generally rounded down to an
integer between 0 and 255 instead to the nearest integer. This may lead to
non-existence of fully saturated values. Use this function to fix this.
If the colormap is used externally (e.g. by gnuplot), use the unmodified map.

This function becomes obsolete the day when the above issue is fixed.
'''

def cmap(cx):
    coff = 1./510.
    N = cx.N
    name = cx.name+'_fitted'
    fract = np.linspace(0, 1, N)
    #rgba = cx(fract) + 1./coff
    red = cx(fract)[:,0] + coff
    grn = cx(fract)[:,1] + coff
    blu = cx(fract)[:,2] + coff
    alf = cx(fract)[:,3] + coff
    
# find where RGBA are > 1, clip
    red[np.where((red > 1.))] = 1.
    grn[np.where((grn > 1.))] = 1.
    blu[np.where((blu > 1.))] = 1.
    alf[np.where((alf > 1.))] = 1.

# put in to tuple & dictionary structures needed
    rr = []
    bb = []
    gg = []
    aa = []
    for k in range(0, N):
        #l = max(k-1, 0)
        rr.append((float(k) / (N - 1.), red[k], red[k]))
        bb.append((float(k) / (N - 1.), blu[k], blu[k]))
        gg.append((float(k) / (N - 1.), grn[k], grn[k]))
        aa.append((float(k) / (N - 1.), alf[k], alf[k]))

    cdict = {'red': rr, 'blue': bb, 'green': gg, 'alpha:': aa}
    return LSC(name, cdict, N=N)
